/**
 * @vue-async/module-loader@1.0.7
 */

"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("@vue-async/utils"),o=(e=require("vue"))&&"object"==typeof e&&"default"in e?e.default:e;function n(e,o){return{add(e,n){if("object"!=typeof e&&"function"!=typeof e)return t.error(!0,'[moduleLoader] dynamicComponent function "add" only accept object or function component as param.');o.commit("dynamicComponent/add",{component:e,position:n})},remove(e,n){if("string"!=typeof e)return t.error(!0,'[moduleLoader] dynamicComponent function "remove" only accept string name of component as param.');o.commit("dynamicComponent/remove",{name:e,position:n})}}}var r={namespaced:!0,state:{GLOBAL:{}},mutations:{add(e,{component:o,position:n="GLOBAL"}){const r=o.component||o,a=o.name||t.getComponentName(r);return a?(e[n]||(e[n]={}),e[n][a]?t.error(!0,`[moduleLoader] async component "${a}" has existed in the ${n}, ignored it.`):void(e[n][a]=o)):t.error(!0,"[moduleLoader] component must be named for dynamic component.")},remove:(e,{name:o,position:n="GLOBAL"})=>e[n]?e[n][o]?void delete e[n][o]:t.error(!0,`[moduleLoader] async component "${o}" does not  exist in the ${n}.`):t.error(!0,`[moduleLoader] position "${n}" does not  exist.`)}};function a(e){let o={};return{emit(e,n){if(!o[e])return t.warn(!0,`[moduleLoader] event "${e}" is triggered, but no listeners，nothing will be happening.`);for(const t of o[e].values())t(n)},on(e,n){"function"==typeof n?(o[e]||(o[e]=new Set),o[e].add(n)):t.error(!0,`[moduleLoader] handler must be a function, but recived ${typeof n}`)},off:(e,n)=>n?o.hasOwnProperty(e)?void o[e].delete(n):t.error(!0,`[moduleLoader] no event name of "${e}" is on listening`):t.warn(!1,"[moduleLoader] handler must be a valid event function"),clear(){o={}},getEvents:()=>o}}const s="undefined"!=typeof navigator&&-1!==navigator.userAgent.indexOf("Trident");function i(e,t){if(!e.hasOwnProperty(t)||!isNaN(t)&&parseInt(t)<e.length)return!0;if(!s)return!1;try{return e[t]&&e[t].parent===window}catch(e){return!0}}let u,d,c;function l(e,o=window){return new Promise((n,r)=>{!function(e){u=d=void 0;for(const t in e)i(e,t)||(u?d||(d=t):u=t,c=t)}(o);const a=document.createElement("script");a.src=e,a.onload=()=>{const e=function(e){let t,o=0,n=!1;for(const r in e)if(!i(e,r)){for(let t=0;t<window.frames.length&&!n;t++){if(window.frames[t]===e[r]){n=!0;break}}if(!n&&(0===o&&r!==u||1===o&&r!==d))return r;o++,t=r}if(t!==c)return t}(o),t=e&&o[e]||{};n(t)},a.onerror=()=>{t.error(!0,`[moduleLoader] script had a problem to create, entry：${e}`),r(new Error("script load error"))},document.body.appendChild(a)})}const m=!0;function f(e){const o=e&&e.default||e;if(t.isFunction(o))return!0;{const{bootstrap:o}=e||{};return t.isFunction(o)}}var p=(e,o)=>function(n,r={}){const{success:a,error:s=(e=>{t.error(m,e)})}=r;o.current=!1;const i=this,u=function e(o,n=(()=>{})){if(Array.isArray(o))return o.reduce((t,o)=>[...t,...e(o)],[]);if(t.isPlainObject(o)){const e=o;return e.entry&&"string"==typeof e.entry?[{...o,styles:e.styles?Array.isArray(e.styles)?e.styles:[e.styles]:[]}]:Object.keys(e).map(t=>"string"==typeof e[t]?{entry:e[t],moduleName:t}:{...e[t],styles:e[t].styles?Array.isArray(e[t].styles)?e[t].styles:[e[t].styles]:[],moduleName:t})}return t.isFunction(o)?[o]:(n(`not support "${typeof o}" type module`,o),[])}(n,s),d=window;return new Promise(n=>Promise.all(u.map(o=>function(o){if(t.isFunction(o)){const t=o.call(i,e);return t&&t instanceof Promise?t:Promise.resolve()}{if(e.prototype.$isServer)return Promise.resolve();const{moduleName:n,entry:r,styles:a=[],args:u}=o;return function(e,t){e.length&&e.map(e=>{const o=document.createElement("link");o.rel="stylesheet",o.type="text/css",o.href=e,t&&(o.dataset.styleFor=t),document.getElementsByTagName("head")[0].appendChild(o)})}(a,n),l(r,d).then(o=>{const{bootstrap:r}=function(e,o,n){if(f(e)){const o=e&&e.default||e;return t.isFunction(o)?{bootstrap:o}:e}t.warn(m,`[moduleLoader] lifecycle not found from ${o} entry exports, fallback to get from window['${o}']`);const r=n[o];if(f(r)){const e=r&&r.default||r;return t.isFunction(e)?{bootstrap:e}:r}throw new Error(`[moduleLoader] You need to export lifecycle functions in ${o} entry`)}(o,n,d);r.call(i,e,u)}).catch(e=>{try{s(e.message,o)}catch{}})}}(o))).then(()=>{o.current=!0}).then(a||n))};function y(e){const n=e&&e.default||e;return t.isPlainObject(n)?Object.keys(n).length>0&&(t.hasOwn(n,"template")||t.hasOwn(n,"render")||t.hasOwn(n,"component")||t.isFunction(n)):n instanceof o}var w=e=>function(e,o){const n=window;return l(o,n).then(o=>function(e,o,n){if(y(e))return e&&e.default||e;t.warn(!0,`[moduleLoader] component not found from ${o} entry exports, fallback to get from window['${o}']`);const r=n[o];if(y(r))return r&&r.default||r;throw new Error(`[moduleLoader] You need to export vue component in ${o} entry`)}(o,e,n))};class h{constructor(e){this._framework={layouts:{}},this._options=e}get framework(){return this._framework}init(e,o){this._options&&Object.entries(this._options).map(([e,o])=>{t.hasOwn(this._framework,e)?t.warn(!0,`参数 ${e} 已在在`):this._framework[e]=o}),!t.hasOwn(this._framework,"addRoutes")&&(this._framework.addRoutes=this._createAddRoutes(e)),!t.hasOwn(this._framework,"addLayouts")&&(this._framework.addLayouts=this._createAddLayouts(e))}_createAddRoutes(e){return o=>{e.$router?e.$router.addRoutes(o):t.error(!0,"vm.$router未定义")}}_createAddLayouts(e){return(o,n)=>{if("string"==typeof o)e.$set(this._framework.layouts,o,n);else if(t.isPlainObject(o)){const e=o;this._framework.layouts=Object.assign(this._framework.layouts,e)}else t.error(!0,"addLayouts中支持字符串(key)或 Object(key/value)格式")}}}h.install=function e(t){if(e.installed)return;e.installed=!0;const o=new t({data:()=>({status:{current:!1}})});Object.defineProperties(t.prototype,{$eventBus:{value:a(),writable:!1},$moduleLoader:{value:p(t,o.status),writable:!1},$componentLoader:{value:w(),writable:!1}});const s=t.prototype._init;t.prototype._init=function(e={}){var a;e.router&&(e=>{return e.beforeEach((e,n,r)=>{if(e.name&&"404"!==e.name&&"page-not-found"!==e.name&&"not-found"!==e.name&&"*"!==e.path)r();else{if(o.status.current)return t(e,n,r);o.$watch(()=>o.status.current,(o,a)=>{o&&!a&&t(e,n,r)})}});function t(t,o,n){const r=t.redirectedFrom||t.fullPath,{resolved:a,location:s}=e.resolve(r);a.name!==t.name?n(s):n()}})(e.router),e.store&&((a=e.store).registerModule("dynamicComponent",r),Object.defineProperty(t.prototype,"$dynamicComponent",{value:n(0,a),writable:!1})),s.call(this,e)},t.$__module_loader_installed__||(t.$__module_loader_installed__=!0,window&&!window.Vue&&(window.Vue=t),t.mixin({beforeCreate(){const e=this.$options;e.moduleLoader?(e.moduleLoader.init(this,e.ssrContext),this.$moduleLoadManager=t.observable(e.moduleLoader.framework)):this.$moduleLoadManager=e.parent&&e.parent.$moduleLoadManager||this}}))},h.installed=!1,h.version="1.0.7";const v=h.install;h.install=e=>{v.call(h,e)},window&&window.Vue&&window.Vue.use(h),exports.default=h;
